## org.exist.xquery
Class BinaryOp

    java.lang.Object
      org.exist.xquery.AbstractExpression
          org.exist.xquery.PathExpr
              org.exist.xquery.BinaryOp

All Implemented Interfaces:
  CompiledExpression, CompiledXQuery, Expression

Direct Known Subclasses:
  GeneralComparison, LogicalOp, NodeComparison, OpNumeric

public abstract class BinaryOp
extends PathExpr

Field Summary

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Constructor Summary
`BinaryOp(XQueryContext context)`

Method Summary
`void` `analyze(AnalyzeContextInfo contextInfo)` Statically analyze the expression and its subexpressions.
`abstract Sequence` `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`Expression` `getLeft()`
`Expression` `getRight()`
`int` `returnsType()` The static return type of the expression.
`void` `setContextDocSet(DocumentSet contextSet)`
`void` `setLeft(Expression expr)`
`void` `setRight(Expression expr)`

Methods inherited from class org.exist.xquery.PathExpr
`accept, add, add, addPath, addPredicate, dump, dump, getASTNode, getCardinality, getContext, getDependencies, getDocumentSet, getExpression, getLastExpression, getLength, getLiteralValue, getSource, isValid, replaceLastExpression, reset, resetState, setContext, setPrimaryAxis, setSource, toString`

Methods inherited from class org.exist.xquery.AbstractExpression
`eval, getContextDocSet, getContextId, getExpressionId, setASTNode`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.exist.xquery.CompiledXQuery
`eval`

Constructor Detail

### BinaryOp

    public BinaryOp(XQueryContext context)

Method Detail

### returnsType

    public int returnsType()

  Description copied from interface: `Expression`
  The static return type of the expression. This method should return one of the type constants defined in class `Type`. If the return type cannot be determined statically, return Type.ITEM.

  Specified by:
    `returnsType` in interface `Expression`
  Overrides:
    `returnsType` in class `PathExpr`

### getLeft

    public Expression getLeft()

### getRight

    public Expression getRight()

### setLeft

    public void setLeft(Expression expr)

### setRight

    public void setRight(Expression expr)

### setContextDocSet

    public void setContextDocSet(DocumentSet contextSet)

  Specified by:
    `setContextDocSet` in interface `Expression`
  Overrides:
    `setContextDocSet` in class `AbstractExpression`

### analyze

    public void analyze(AnalyzeContextInfo contextInfo)
                 throws XPathException

  Description copied from interface: `Expression`
  Statically analyze the expression and its subexpressions. During the static analysis phase, the query engine can detect unknown variables and some type errors.

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `PathExpr`
  Throws:
    `XPathException`

### eval

    public abstract Sequence eval(Sequence contextSequence,
                                  Item contextItem)
                           throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Overrides:
    `eval` in class `PathExpr`
  Throws:
    `XPathException`

Copyright (C) Wolfgang Meier. All rights reserved.